using EVCB_OCPP.Packet.Features;
using EVCB_OCPP.Packet.Messages.SubTypes;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace EVCB_OCPP.Packet.Messages.Security
{
    public class LogStatusNotificationRequest
    {
        public LogStatusNotificationRequest()
        {
            Action = Actions.LogStatusNotification.ToString();
        }

        /// <summary>
        /// This contains the status of the log upload
        /// </summary>
        [Required]
        [JsonConverter(typeof(StringEnumConverter))]
        public UploadLogStatusEnumType status { set; get; }

        /// <summary>
        /// The request id that was provided in the GetLog.req that started this log
        ///upload.
        /// </summary>
        public int requestId { set; get; }

        [JsonIgnore]
        public string Action { set; get; }

        public bool TransactionRelated()
        {
            return false;
        }

        public bool Validate()
        {
            return Validator.TryValidateObject(this, new ValidationContext(this), null, true);
        }

    }
}
